/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.87 Revision 1.112
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.87 2011/04/06 14:22:14 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.112 2012/01/17 11:20:03 johu Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# over time as new EAPI versions are approved. 14# over time as new EAPI versions are approved.
15 15
16# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
17# @DESCRIPTION:
18# If set to "none", do nothing.
19# For any other value, add selinux to IUSE, and depending on that useflag
20# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
21: ${KDE_SELINUX_MODULE:=none}
22
16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED 23# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION: 24# @DESCRIPTION:
18# For proper description see virtualx.eclass manpage. 25# For proper description see virtualx.eclass manpage.
19# Here we redefine default value to be manual, if your package needs virtualx 26# Here we redefine default value to be manual, if your package needs virtualx
20# for tests you should proceed with setting VIRTUALX_REQUIRED=test. 27# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21: ${VIRTUALX_REQUIRED:=manual} 28: ${VIRTUALX_REQUIRED:=manual}
22 29
23inherit kde4-functions fdo-mime gnome2-utils base virtualx versionator eutils 30inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils
24 31
25if [[ ${BUILD_TYPE} = live ]]; then 32if [[ ${BUILD_TYPE} = live ]]; then
26 case ${KDE_SCM} in 33 case ${KDE_SCM} in
27 svn) inherit subversion ;; 34 svn) inherit subversion ;;
28 git) inherit git ;; 35 git) inherit git-2 ;;
29 esac 36 esac
30fi 37fi
31 38
32# @ECLASS-VARIABLE: CMAKE_REQUIRED 39# @ECLASS-VARIABLE: CMAKE_REQUIRED
33# @DESCRIPTION: 40# @DESCRIPTION:
39if [[ ${CMAKE_REQUIRED} = always ]]; then 46if [[ ${CMAKE_REQUIRED} = always ]]; then
40 buildsystem_eclass="cmake-utils" 47 buildsystem_eclass="cmake-utils"
41 export_fns="src_configure src_compile src_test src_install" 48 export_fns="src_configure src_compile src_test src_install"
42fi 49fi
43 50
44# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
45if [[ -n ${KDE_MINIMAL} ]]; then
46 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
47 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
48 done
49 unset slot
50 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
51else
52 KDE_MINIMAL_VALID=1
53fi
54
55# @ECLASS-VARIABLE: KDE_MINIMAL 51# @ECLASS-VARIABLE: KDE_MINIMAL
56# @DESCRIPTION: 52# @DESCRIPTION:
57# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal 53# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
58# version for apps to work. Currently defaults to 4.4 54# version for apps to work. Currently defaults to 4.4
59# One may override this variable to raise version requirements. 55# One may override this variable to raise version requirements.
60# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
61# Note that it is fixed to ${SLOT} for kde-base packages. 56# Note that it is fixed to ${PV} for kde-base packages.
62KDE_MINIMAL="${KDE_MINIMAL:-4.4}" 57KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
63 58
64# Set slot for KDEBASE known packages 59# Set slot for KDEBASE known packages
65case ${KDEBASE} in 60case ${KDEBASE} in
66 kde-base) 61 kde-base)
67 SLOT=$(_calculate_kde_slot) 62 SLOT=4
68 [[ -z ${SLOT} ]] && die "Unsupported ${PV}"
69 KDE_MINIMAL="${SLOT}" 63 KDE_MINIMAL="${PV}"
70 ;; 64 ;;
71 koffice) 65 koffice)
72 SLOT="2" 66 SLOT="2"
73 ;; 67 ;;
74 kdevelop) 68 kdevelop)
131# @DESCRIPTION: 125# @DESCRIPTION:
132# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'. 126# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
133# This variable must be set before inheriting any eclasses. Defaults to 'never'. 127# This variable must be set before inheriting any eclasses. Defaults to 'never'.
134MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}" 128MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
135 129
136# @ECLASS-VARIABLE: WEBKIT_REQUIRED
137# @DESCRIPTION:
138# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
139# This variable must be set before inheriting any eclasses. Defaults to 'never'.
140WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
141
142# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 130# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
143# @DESCRIPTION: 131# @DESCRIPTION:
144# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 132# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
145# This variable must be set before inheriting any eclasses. Defaults to 'never'. 133# This variable must be set before inheriting any eclasses. Defaults to 'never'.
146CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}" 134CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
165# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE 153# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
166# @DESCRIPTION: 154# @DESCRIPTION:
167# Set this varible if you want your live package to manage its 155# Set this varible if you want your live package to manage its
168# translations. (Mostly all kde ebuilds does not ship documentation 156# translations. (Mostly all kde ebuilds does not ship documentation
169# and translations in live ebuilds) 157# and translations in live ebuilds)
170if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} && ${KDEBASE} != "kde-base" ]]; then 158if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
171 KDE_HANDBOOK=never 159 # Kdebase actualy provides the handbooks even for live stuff
160 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
172 KDE_LINGUAS="" 161 KDE_LINGUAS=""
173fi 162fi
174 163
175# Setup packages inheriting this eclass 164# Setup packages inheriting this eclass
176case ${KDEBASE} in 165case ${KDEBASE} in
178 HOMEPAGE="http://www.kde.org/" 167 HOMEPAGE="http://www.kde.org/"
179 LICENSE="GPL-2" 168 LICENSE="GPL-2"
180 if [[ $BUILD_TYPE = live ]]; then 169 if [[ $BUILD_TYPE = live ]]; then
181 # Disable tests for live ebuilds 170 # Disable tests for live ebuilds
182 RESTRICT+=" test" 171 RESTRICT+=" test"
183 # Live ebuilds in kde-base default to kdeprefix by default 172 fi
184 IUSE+=" +kdeprefix" 173
185 else 174 # Only add the kdeprefix USE flag for older versions, to help
186 # All other ebuild types default to -kdeprefix as before 175 # non-portage package managers handle the upgrade
176 if [[ ${PV} < 4.6.4 && ( ( ${KMNAME} != kdepim && ${PN} != kdepim-runtime ) || ${PV} < 4.6 ) ]]; then
187 IUSE+=" kdeprefix" 177 IUSE+=" kdeprefix"
188 fi 178 fi
179
189 # This code is to prevent portage from searching GENTOO_MIRRORS for 180 # This code is to prevent portage from searching GENTOO_MIRRORS for
190 # packages that will never be mirrored. (As they only will ever be in 181 # packages that will never be mirrored. (As they only will ever be in
191 # the overlay). 182 # the overlay).
192 case ${PV} in 183 case ${PV} in
193 *9999* | 4.?.[6-9]?) 184 *9999* | 4.?.[6-9]?)
194 RESTRICT+=" mirror" 185 RESTRICT+=" mirror"
195 ;; 186 ;;
196 esac 187 esac
197 # Block installation of other SLOTS unless kdeprefix
198 RDEPEND+=" $(block_other_slots)"
199 ;; 188 ;;
200 koffice) 189 koffice)
201 HOMEPAGE="http://www.koffice.org/" 190 HOMEPAGE="http://www.koffice.org/"
202 LICENSE="GPL-2" 191 LICENSE="GPL-2"
203 ;; 192 ;;
208esac 197esac
209 198
210# @ECLASS-VARIABLE: QT_MINIMAL 199# @ECLASS-VARIABLE: QT_MINIMAL
211# @DESCRIPTION: 200# @DESCRIPTION:
212# Determine version of qt we enforce as minimal for the package. 201# Determine version of qt we enforce as minimal for the package.
213if slot_is_at_least 4.6 "${KDE_MINIMAL}"; then 202if version_is_at_least 4.7.80 "${KDE_MINIMAL}"; then
203 QT_MINIMAL="${QT_MINIMAL:-4.7.4}"
204else
214 QT_MINIMAL="${QT_MINIMAL:-4.7.0}" 205 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
215else
216 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
217fi 206fi
218 207
219# Declarative dependencies 208# Declarative dependencies
220qtdeclarativedepend=" 209qtdeclarativedepend="
221 >=x11-libs/qt-declarative-${QT_MINIMAL}:4 210 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
277 ;; 266 ;;
278 *) ;; 267 *) ;;
279esac 268esac
280unset qtmultimediadepend 269unset qtmultimediadepend
281 270
282# WebKit dependencies
283case ${KDE_REQUIRED} in
284 always)
285 qtwebkitusedeps="[kde]"
286 ;;
287 optional)
288 qtwebkitusedeps="[kde?]"
289 ;;
290 *) ;;
291esac
292qtwebkitdepend="
293 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
294"
295unset qtwebkitusedeps
296case ${WEBKIT_REQUIRED} in
297 always)
298 COMMONDEPEND+=" ${qtwebkitdepend}"
299 ;;
300 optional)
301 IUSE+=" webkit"
302 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
303 ;;
304 *) ;;
305esac
306unset qtwebkitdepend
307
308# CppUnit dependencies 271# CppUnit dependencies
309cppuintdepend=" 272cppuintdepend="
310 dev-util/cppunit 273 dev-util/cppunit
311" 274"
312case ${CPPUNIT_REQUIRED} in 275case ${CPPUNIT_REQUIRED} in
319 ;; 282 ;;
320 *) ;; 283 *) ;;
321esac 284esac
322unset cppuintdepend 285unset cppuintdepend
323 286
287
288# WebKit use dependencies
289case ${KDE_REQUIRED} in
290 always)
291 qtwebkitusedeps="[kde]"
292 ;;
293 optional)
294 qtwebkitusedeps="[kde?]"
295 ;;
296 *) ;;
297esac
324# KDE dependencies 298# KDE dependencies
325# Qt accessibility classes are needed in various places, bug 325461 299# Qt accessibility classes are needed in various places, bug 325461
326kdecommondepend=" 300kdecommondepend="
327 dev-lang/perl 301 dev-lang/perl
328 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl] 302 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
330 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde] 304 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
331 >=x11-libs/qt-script-${QT_MINIMAL}:4 305 >=x11-libs/qt-script-${QT_MINIMAL}:4
332 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support] 306 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
333 >=x11-libs/qt-svg-${QT_MINIMAL}:4 307 >=x11-libs/qt-svg-${QT_MINIMAL}:4
334 >=x11-libs/qt-test-${QT_MINIMAL}:4 308 >=x11-libs/qt-test-${QT_MINIMAL}:4
309 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
335 !aqua? ( 310 !aqua? (
336 x11-libs/libXext 311 x11-libs/libXext
337 x11-libs/libXt 312 x11-libs/libXt
338 x11-libs/libXxf86vm 313 x11-libs/libXxf86vm
314 x11-libs/libXcomposite
315 x11-libs/libxkbfile
339 ) 316 )
340" 317"
341 318
342if [[ ${PN} != kdelibs ]]; then 319if [[ ${PN} != kdelibs ]]; then
343 kdecommondepend+=" $(add_kdebase_dep kdelibs)" 320 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
374# all packages needs oxygen icons for basic iconset 351# all packages needs oxygen icons for basic iconset
375if [[ ${PN} != oxygen-icons ]]; then 352if [[ ${PN} != oxygen-icons ]]; then
376 kderdepend+=" $(add_kdebase_dep oxygen-icons)" 353 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
377fi 354fi
378 355
379# add a dependency over kde-l10n if EAPI4 is around 356# add a dependency over kde-l10n if EAPI4 or better is around
380if [[ ${KDEBASE} != "kde-base" ]] && [[ -n ${KDE_LINGUAS} ]] && has "${EAPI:-0}" 4; then 357if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
381 usedep=''
382 for _lingua in ${KDE_LINGUAS}; do 358 for _lingua in ${KDE_LINGUAS}; do
383 [[ -n ${usedep} ]] && usedep+="," 359 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
384 usedep+="linguas_${_lingua}(+)?" 360 # but only for selected ones.
361 # this can't be done on one line because if user doesn't use any localisation
362 # then he is probably not interested in kde-l10n at all.
363 kderdepend+="
364 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
365 "
385 done 366 done
386 # if our package has lignuas pull in kde-l10n with selected lingua
387 kderdepend+=" $(add_kdebase_dep kde-l10n ${usedep})"
388 unset usedep _lingua 367 unset _lingua
389fi 368fi
390 369
391kdehandbookdepend=" 370kdehandbookdepend="
392 app-text/docbook-xml-dtd:4.2 371 app-text/docbook-xml-dtd:4.2
393 app-text/docbook-xsl-stylesheets 372 app-text/docbook-xsl-stylesheets
407 ;; 386 ;;
408 *) ;; 387 *) ;;
409esac 388esac
410unset kdehandbookdepend kdehandbookrdepend 389unset kdehandbookdepend kdehandbookrdepend
411 390
391case ${KDE_SELINUX_MODULE} in
392 none) ;;
393 *)
394 IUSE+=" selinux"
395 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
396 ;;
397esac
398
412case ${KDE_REQUIRED} in 399case ${KDE_REQUIRED} in
413 always) 400 always)
414 IUSE+=" aqua" 401 IUSE+=" aqua"
415 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}" 402 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
416 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}" 403 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
433 420
434# Accumulate dependencies set by this eclass 421# Accumulate dependencies set by this eclass
435DEPEND+=" ${COMMONDEPEND}" 422DEPEND+=" ${COMMONDEPEND}"
436RDEPEND+=" ${COMMONDEPEND}" 423RDEPEND+=" ${COMMONDEPEND}"
437unset COMMONDEPEND 424unset COMMONDEPEND
438
439# Add experimental kdeenablefinal, masked by default
440IUSE+=" kdeenablefinal"
441 425
442# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 426# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
443# koffice ebuild, the URI should be set in the ebuild itself 427# koffice ebuild, the URI should be set in the ebuild itself
444_calculate_src_uri() { 428_calculate_src_uri() {
445 debug-print-function ${FUNCNAME} "$@" 429 debug-print-function ${FUNCNAME} "$@"
463 fi 447 fi
464 _kmname_pv="${_kmname}-${PV}" 448 _kmname_pv="${_kmname}-${PV}"
465 case ${KDEBASE} in 449 case ${KDEBASE} in
466 kde-base) 450 kde-base)
467 case ${PV} in 451 case ${PV} in
468 4.[456].8[05] | 4.[456].9[023568] | 4.5.94.1) 452 4.[456789].8[05] | 4.[456789].9[0235678])
469 # Unstable KDE SC releases 453 # Unstable KDE SC releases
470 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" 454 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2"
455 if ! version_is_at_least 4.6.80 ${PV}
456 then
471 # KDEPIM IS SPECIAL 457 # KDEPIM IS SPECIAL
472 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/src/${_kmname_pv}.tar.bz2" 458 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2"
473 ;; 459 fi
474 4.4.[6789] | 4.4.1?)
475 # Stable kdepim releases
476 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
477 ;; 460 ;;
478 *) 461 *)
479 # Stable KDE SC releases 462 # Stable KDE SC releases
480 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" 463 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
464 if ! version_is_at_least 4.6.80 ${PV}
465 then
466 # KDEPIM IS SPECIAL
467 # TODO: It might not be with KDE 4.7 (see above)
468 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
469 fi
481 ;; 470 ;;
482 esac 471 esac
483 ;; 472 ;;
484 koffice) 473 koffice)
485 case ${PV} in 474 case ${PV} in
486 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;; 475 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
506 # trunk 495 # trunk
507 branch_prefix="trunk/KDE" 496 branch_prefix="trunk/KDE"
508 ;; 497 ;;
509 *) 498 *)
510 # branch 499 # branch
511 branch_prefix="branches/KDE/${SLOT}" 500 branch_prefix="branches/KDE/$(get_kde_version)"
512 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX 501 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
513 # @DESCRIPTION 502 # @DESCRIPTION
514 # Suffix appended to ESVN_PROJECT depending on fetched branch. 503 # Suffix appended to ESVN_PROJECT depending on fetched branch.
515 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise. 504 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
516 ESVN_PROJECT_SUFFIX="-${PV}" 505 ESVN_PROJECT_SUFFIX="-${PV}"
590 else 579 else
591 _kmname=${PN} 580 _kmname=${PN}
592 fi 581 fi
593 582
594 # default branching 583 # default branching
595 case ${PV} in 584 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
596 9999*) ;; 585 EGIT_BRANCH="KDE/$(get_kde_version)"
597 *)
598 # set EGIT_BRANCH and EGIT_COMMIT to ${SLOT}
599 case ${_kmname} in
600 kdeplasma-addons | kdepim | kdepim-runtime | kdepimlibs)
601 EGIT_BRANCH="${SLOT}"
602 ;;
603 *) EGIT_BRANCH="KDE/${SLOT}" ;;
604 esac
605 ;;
606 esac
607 586
608 case $_kmname in 587 # default repo uri
609 kdepim|kdepim-runtime)
610 case ${PV} in
611 # kdepim still did not branch
612 4.6.9999)
613 EGIT_BRANCH="master"
614 ;;
615 esac
616 ;;
617 esac
618 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}" 588 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
619 EGIT_PROJECT="${_kmname}"
620 589
621 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}" 590 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
622 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}" 591 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
623 ;; 592 ;;
624 esac 593 esac
632debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 601debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
633 602
634# @ECLASS-VARIABLE: PREFIX 603# @ECLASS-VARIABLE: PREFIX
635# @DESCRIPTION: 604# @DESCRIPTION:
636# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 605# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
637# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 606# kde-base packages go into KDE4 installation directory (/usr).
638# No matter the PREFIX, package will be built against KDE installed in KDEDIR. 607# No matter the PREFIX, package will be built against KDE installed in /usr.
639 608
640# @FUNCTION: kde4-base_pkg_setup 609# @FUNCTION: kde4-base_pkg_setup
641# @DESCRIPTION: 610# @DESCRIPTION:
642# Do the basic kdeprefix KDEDIR settings and determine with which kde should 611# Do some basic settings
643# optional applications link
644kde4-base_pkg_setup() { 612kde4-base_pkg_setup() {
645 debug-print-function ${FUNCNAME} "$@" 613 debug-print-function ${FUNCNAME} "$@"
646 614
647 # QA ebuilds 615 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
648 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})." 616 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
617 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
618 fi
619
620 if use_if_iuse kdeprefix; then
621 eerror "Sorry, kdeprefix support has been removed."
622 eerror "Please remove kdeprefix from your USE variable."
623 die "kdeprefix support has been removed"
624 fi
625
626 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
627 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
628 has_version kde-base/kdelibs[kdeprefix]; then
629 eerror "Sorry, kdeprefix support has been removed."
630 eerror "Please rebuild kdelibs without kdeprefix support."
631 die "kdeprefix support has been removed"
632 fi
649 633
650 # Don't set KDEHOME during compilation, it will cause access violations 634 # Don't set KDEHOME during compilation, it will cause access violations
651 unset KDEHOME 635 unset KDEHOME
652 636
653 if [[ ${KDEBASE} = kde-base ]]; then 637 # Check if gcc compiler is fresh enough.
654 if use kdeprefix; then 638 # In theory should be in pkg_pretend but we check it only for kdelibs there
655 KDEDIR=/usr/kde/${SLOT} 639 # and for others we do just quick scan in pkg_setup because pkg_pretend
656 else 640 # executions consume quite some time.
657 KDEDIR=/usr 641 # We can only do this for EAPI 4 or later because the MERGE_TYPE variable
642 # is otherwise undefined.
643 if [[ ${EAPI:-0} != 3 ]]; then
644 if [[ ${MERGE_TYPE} != binary ]]; then
645 [[ $(gcc-major-version) -lt 4 ]] || \
646 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
647 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
658 fi 648 fi
659 : ${PREFIX:=${KDEDIR}}
660 else
661 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
662 KDEDIR=
663 local kde_minimal_met
664 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
665 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
666 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
667 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
668 KDEDIR=/usr/kde/${slot}
669 else
670 KDEDIR=/usr
671 fi
672 break;
673 fi
674 done
675 unset slot
676
677 # Bail out if kdelibs required but not found
678 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
679 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
680 else
681 [[ -z ${KDEDIR} ]] && KDEDIR=/usr
682 fi 649 fi
683 650
651 KDEDIR=/usr
684 : ${PREFIX:=/usr} 652 : ${PREFIX:=/usr}
685 fi 653 EKDEDIR=${EPREFIX}/usr
686 EKDEDIR=${EPREFIX}${KDEDIR}
687 654
688 # Point pkg-config path to KDE *.pc files
689 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
690 # Point to correct QT plugins path 655 # Point to correct QT plugins path
691 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/" 656 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
692 657
693 # Fix XDG collision with sandbox 658 # Fix XDG collision with sandbox
694 export XDG_CONFIG_HOME="${T}" 659 export XDG_CONFIG_HOME="${T}"
695} 660}
696 661
705 svn) 670 svn)
706 migrate_store_dir 671 migrate_store_dir
707 subversion_src_unpack 672 subversion_src_unpack
708 ;; 673 ;;
709 git) 674 git)
710 git_src_unpack 675 git-2_src_unpack
711 ;; 676 ;;
712 esac 677 esac
713 else 678 else
714 unpack ${A} 679 unpack ${A}
715 fi 680 fi
732 fi 697 fi
733 698
734 # Enable/disable handbooks for kde4-base packages 699 # Enable/disable handbooks for kde4-base packages
735 # kde-l10n inherits kde4-base but is metpackage, so no check for doc 700 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
736 # kdelibs inherits kde4-base but handle installing the handbook itself 701 # kdelibs inherits kde4-base but handle installing the handbook itself
737 if ! has kde4-meta ${INHERITED} && has handbook ${IUSE//+}; then 702 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
738 if [[ ${KDEBASE} == kde-base ]]; then 703 if [[ ${KDEBASE} == kde-base ]]; then
739 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then 704 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
740 # documentation in kde4-functions 705 # documentation in kde4-functions
741 : ${KDE_DOC_DIRS:=doc} 706 : ${KDE_DOC_DIRS:=doc}
742 local dir 707 local dir
743 for dir in ${KDE_DOC_DIRS}; do 708 for dir in ${KDE_DOC_DIRS}; do
744 sed -e "/^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)/s/^/#DONOTCOMPILE /" \ 709 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
745 -e "/^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)/s/^/#DONOTCOMPILE /" \ 710 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
746 -e "/^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)/s/^/#DONOTCOMPILE /" \ 711 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
747 -e "/^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)/s/^/#DONOTCOMPILE /" \ 712 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
748 -i CMakeLists.txt || die "failed to comment out handbook" 713 -i CMakeLists.txt || die "failed to comment out handbook"
749 done 714 done
750 fi 715 fi
751 else 716 else
752 enable_selected_doc_linguas 717 enable_selected_doc_linguas
771 # Inject library dependencies 736 # Inject library dependencies
772 if [[ -n ${KMLOADLIBS} ]] ; then 737 if [[ -n ${KMLOADLIBS} ]] ; then
773 load_library_dependencies 738 load_library_dependencies
774 fi 739 fi
775 740
776 # Replace KDE4Workspace library targets
777 find "${S}" -name CMakeLists.txt \
778 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
779 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
780 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
781 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
782 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
783 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
784 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
785 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
786 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
787 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
788 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
789 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
790 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
791 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
792 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
793 || die 'failed to replace KDE4Workspace library targets'
794
795 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/... 741 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
796 if [[ -z ${KDEBASE} ]]; then 742 if [[ -z ${KDEBASE} ]]; then
797 find "${S}" -name "*.docbook" \ 743 find "${S}" -name "*.docbook" \
798 -exec sed -i -r \ 744 -exec sed -i -r \
799 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \ 745 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
808 debug-print-function ${FUNCNAME} "$@" 754 debug-print-function ${FUNCNAME} "$@"
809 755
810 # Build tests in src_test only, where we override this value 756 # Build tests in src_test only, where we override this value
811 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF) 757 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
812 758
813 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then 759 if use_if_iuse debug; then
814 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
815 fi
816
817 if has debug ${IUSE//+} && use debug; then
818 # Set "real" debug mode 760 # Set "real" debug mode
819 CMAKE_BUILD_TYPE="Debugfull" 761 CMAKE_BUILD_TYPE="Debugfull"
820 else 762 else
821 # Handle common release builds 763 # Handle common release builds
822 append-cppflags -DQT_NO_DEBUG 764 append-cppflags -DQT_NO_DEBUG
829 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}") 771 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
830 772
831 # Use colors 773 # Use colors
832 QTEST_COLORED=1 774 QTEST_COLORED=1
833 775
834 # Shadow existing /usr installations 776 # Shadow existing installations
835 unset KDEDIRS 777 unset KDEDIRS
836 778
837 # Handle kdeprefix-ed KDE
838 if [[ ${KDEDIR} != /usr ]]; then
839 # Override some environment variables - only when kdeprefix is different,
840 # to not break ccache/distcc
841 PATH="${EKDEDIR}/bin:${PATH}"
842
843 # Append library search path
844 append-ldflags -L"${EKDEDIR}/$(get_libdir)"
845
846 # Append full RPATH
847 cmakeargs+=(-DCMAKE_SKIP_RPATH=OFF)
848
849 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
850 # when more are present
851 cmakeargs+=(-DCMAKE_SYSTEM_PREFIX_PATH="${EKDEDIR}")
852 fi
853
854 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling 779 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
855 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/lib/qt4) 780 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
856 #kde-config -path data unavailable when cross-compiling 781 #kde-config -path data unavailable when cross-compiling
857 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/) 782 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
858 783
859 # Handle kdeprefix in application itself
860 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
861 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 784 # sysconf needs to be /etc, not /usr/etc
862 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc) 785 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
863 fi
864 786
865 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then 787 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
866 mycmakeargs=(${mycmakeargs}) 788 mycmakeargs=(${mycmakeargs})
867 fi 789 fi
868 790
934 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})" 856 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
935 done 857 done
936 fi 858 fi
937 859
938 cmake-utils_src_install 860 cmake-utils_src_install
861
862 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
863 # because then khelpcenter can't find the docs
864 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
865 docompress -x ${PREFIX}/share/doc/HTML
939} 866}
940 867
941# @FUNCTION: kde4-base_pkg_preinst 868# @FUNCTION: kde4-base_pkg_preinst
942# @DESCRIPTION: 869# @DESCRIPTION:
943# Function storing icon caches 870# Function storing icon caches
944kde4-base_pkg_preinst() { 871kde4-base_pkg_preinst() {
945 debug-print-function ${FUNCNAME} "$@" 872 debug-print-function ${FUNCNAME} "$@"
946 873
947 gnome2_icon_savelist 874 gnome2_icon_savelist
875 if [[ ${BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
876 subversion_pkg_preinst
877 fi
948} 878}
949 879
950# @FUNCTION: kde4-base_pkg_postinst 880# @FUNCTION: kde4-base_pkg_postinst
951# @DESCRIPTION: 881# @DESCRIPTION:
952# Function to rebuild the KDE System Configuration Cache after an application has been installed. 882# Function to rebuild the KDE System Configuration Cache after an application has been installed.
957 fdo-mime_desktop_database_update 887 fdo-mime_desktop_database_update
958 fdo-mime_mime_database_update 888 fdo-mime_mime_database_update
959 buildsycoca 889 buildsycoca
960 890
961 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 891 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
962 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
963 echo
964 ewarn "WARNING! you have kdeenable final useflag enabled."
965 ewarn "This useflag needs to be enabled on ALL kde using packages and"
966 ewarn "is known to cause issues."
967 ewarn "You are using this setup at your own risk and the kde team does not"
968 ewarn "take responsibilities for dead kittens."
969 echo
970 fi
971 if [[ ${BUILD_TYPE} = live ]]; then 892 if [[ ${BUILD_TYPE} = live ]]; then
972 echo 893 echo
973 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}" 894 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
974 einfo "Use it at your own risk." 895 einfo "Use it at your own risk."
975 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!" 896 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
976 echo
977 elif [[ ${BUILD_TYPE} != live ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then
978 # warning about kdeprefix for non-live users
979 echo
980 ewarn "WARNING! You have the kdeprefix useflag enabled."
981 ewarn "This setting is strongly discouraged and might lead to potential trouble"
982 ewarn "with KDE update strategies."
983 ewarn "You are using this setup at your own risk and the kde team does not"
984 ewarn "take responsibilities for dead kittens."
985 echo 897 echo
986 fi 898 fi
987 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta 899 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
988 if [[ ${KDEBASE} != kde-base ]] && \ 900 if [[ ${KDEBASE} != kde-base ]] && \
989 ! has_version 'kde-base/kdebase-runtime-meta' && \ 901 ! has_version 'kde-base/kdebase-runtime-meta' && \

Legend:
Removed from v.1.87  
changed lines
  Added in v.1.112

  ViewVC Help
Powered by ViewVC 1.1.20